# procedimiento para extraer de los archivos *.MAG.* generados
# por PHOT la informacion necesaria para armar el archivo de
# entrada al programa de reduccion POLRED.
#
# el script extrae de los archivos de fotometria los campos
# IMAGE, ID, MSKY, NSKY, RAPERT, SUM y AREA (los tres ultimos
# para todas las aperturas calculadas), y de la cabecera de las
# imagenes los keywords FILTER, HWPLATE, SAVART, DATE-OBS, y UT.
#
# El unico parametro de entrada requerido es:
#
# NAPER = numero de aperturas para las que se obtuvo fotometria
#
# con estas cantidades arma un archivo final que sirve de entrada
# al programa de reduccion. En ese archivo listara para cada
# observacion ID, MSKY, NSKY, RAPERT, SUM y AREA (los tres ultimos 
# para todas las aperturas calculadas), FILTER, HWPLATE, SAVART, 
# DATE-OBS, y UT.
#
# esta tarea aceptahasta 8 aperturas diferentes.
# 
# Noviembre 2012
#

procedure polext (archin, archout)
int    naper=1    {min=1, max=8, prompt="number of apertures"}

string archin        {prompt="photometry files"}
string archout       {prompt="output file"}
 
struct *lista,*lista1

begin
  string tfile,tfile1,tfile2,outfile,arch,arch1,arch2
  string car,imag,fil,fecha,hora
  struct fields,linea
  int ii,jj
  real hw,sav

# inicializa archivos y punteros

  arch=archin

# si la entrada es una lista la desarrolla

  car=substr(arch,1,1)
  if(car == "@"){
    lista1=substr(arch,2,strlen(arch))
    arch1=""
    while(fscan(lista1,arch2) != EOF){
      arch1=arch1//","//arch2
    }
    arch=substr(arch1,2,strlen(arch1))
  }

  outfile=archout
  if(access(outfile)) delete(outfile,ver-)

  fields="image,id,msky,nsky,rapert[1-"//naper//"],sum[1-"//naper//"],area[1-"//naper//"]"

# hace un TXDUMP de los archivos de salida de la fotometria
# a un archivo temporario

  tfile = mktemp("./temp")
  txdump(arch,fields,expr+,headers-,>>tfile)
  
# ahora arma el archivo de salida

  tfile1= mktemp("./temp")
  lista=tfile

  while(fscan(lista,linea) != EOF){

   ii=stridx(" ",linea)
   imag=substr(linea,1,ii-1)

# evita secciones de imagen que pueden estar truncadas

   ii=stridx("[",imag)
   if(ii != 0)imag=substr(imag,1,ii-1)

# extrae informacion de la cabecera de la imagen

   imgets(imag,"filter")
   fil=str(imgets.value)
   imgets(imag,"hwplate")
   hw=real(imgets.value)
   imgets(imag,"savart")
   sav=real(imgets.value)
   imgets(imag,"date-obs")
   fecha=str(imgets.value)
   imgets(imag,"ut")
   hora=str(imgets.value)

# guarda en el archivo de salida
  
   ii=stridx(" ",linea)
   jj=strlen(linea)
   print(imag," ",substr(linea,ii+1,jj)," ",fil," ",hw,sav,fecha," ",hora,>>tfile1)
  }

# salida
  
  copy(tfile1,outfile)
  delete(tfile,ver-)
  delete(tfile1,ver-)
  
  lista=""

end
