# script para encontrar los desplazamientos entre imagenes y
# armar los archivos de coordenadas necesarios para automatizar
# la fotometria.
#
# al script se entra con un listado de imagenes donde se toma de
# referencia la primera, el archivo con las coordenadas de los
# objetos en esta imagen, y el listado de los nombres de salida
# para los archivos de coordenadas de las restantes imagenes.
#
#
# 
# Noviembre 2012
#

procedure registra (archin,archout,shfref)

string archin        {prompt="images to process"}
string archout       {prompt="output coordinates files"}
string shfref        {prompt="file with the objects coordinates in ref. image"}
 
struct *lista,*lista1,*lista2

begin
  string arch,coorde,car,datos,arch1
  string infile,outfile
  string tfile,tfile1,tfile2,tfile3

  struct linea
  int nn,imtot
  real xref,yref,cx,cy,posx,posy

# inicializa archivos y punteros

  infile=archin
  outfile=archout
  coorde=shfref

# se asegura que las imagenes a procesar esten en una lista

  tfile=mktemp("temp")
  car=substr(infile,1,1)
  if(car != "@"){
    files(infile,>>tfile)
  }else{
    if(access(tfile)) delete(tfile,ver-)
    copy(substr(infile,2,strlen(infile)),tfile)
  }

# se asegura que los archivos de salida esten en una lista

  tfile1=mktemp("temp")
  car=substr(outfile,1,1)
  if(car != "@"){
    files(outfile,>>tfile1)
  }else{
    if(access(tfile1)) delete(tfile1,ver-)
    copy(substr(outfile,2,strlen(outfile)),tfile1)
  }

# marca la estrella de referencia en las imagenes
# para calcular los shifts

  imtot=0
  tfile3=mktemp("temp")
  lista=tfile
  lista1=tfile1

  while(fscan(lista,arch) != EOF){

# obtiene nombre archivo de salida
 
    datos=fscan(lista1,arch1)
    print("# XCEN     YCEN", >> arch1)

# despliega imagen

    display(arch,frame=1)

    print("")
    if(imtot == 0){
      print("Mark a reference star...")
    }else{
      print("Mark the same reference star...")
    }
    print("")
    print("<r> plots the radial profile")
    print("<a> save the coordinates")
    print("<q> to exit")

    tfile2=mktemp("temp")
    imexa(arch,frame=1,logfile=tfile2//"",keeplog+,>>tfile3//"")
  
# lee coordenadas

    nn=0
    lista2=tfile2
    while(fscan(lista2,linea) != EOF){
      nn=nn+1
      if(nn == 3)datos=fscan(linea,cx,cy)
    }

    print("")
    print("Image: ",arch," Coord.: ",cx,cy)
    lista2=""
    delete(tfile2,ver-)

# es la primera imagen?

    if(imtot == 0){
      xref=cx
      yref=cy
    }

# calcula y guarda el archivo de coordenadas para
# esta imagen

    lista2=coorde
    while(fscan(lista2,linea) != EOF){
      if(substr(linea,1,1) != "#"){
        datos=fscan(linea,posx,posy)
        posx=posx+cx-xref
        posy=posy+cy-yref
        print(posx,posy,>> arch1)
      }
    }
    lista2=""
    imtot=imtot+1
  }

# salida
  
  delete(tfile,ver-)
  delete(tfile1,ver-)
  delete(tfile3,ver-)
  
  lista=""
  lista1=""

end
